using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace _87K_do
{
    public partial class Form1 : Form
    {
        int SlotNumber = 0;

        public Form1()
        {
            InitializeComponent();
            InitData();
        }
        private void InitData()
        {
            cmbSlot.SelectedIndex = 2;
        }
      
        private void btnWriteDO_Click(object sender, EventArgs e)
        {
            IntPtr hPort;
            //Open default com port , default com port is com 1
            hPort = PACNET.UART.Open("");

            //Get slot data
            SlotNumber = Convert.ToInt16(cmbSlot.Text);

            //Get Channel data
            int intChannel = Convert.ToInt16(txtChannel.Text);

            //Write data
            bool iRet = PACNET.PAC_IO.WriteDO(hPort, SlotNumber, intChannel, Convert.ToUInt32(txtHexValue.Text, 16));

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            IntPtr hPort;

            //Open default com port , default com port is com 1
            hPort = PACNET.UART.Open("");

            //Set do data be '0' to clear
            bool iRet = PACNET.PAC_IO.WriteDO(hPort, SlotNumber, Convert.ToInt16(txtChannel.Text), 0);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
            txtHexValue.Text = "0";
        }

        private void btnWriteDO_MF_Click(object sender, EventArgs e)
        {
            IntPtr hPort;
            //Open default com port , default com port is com 1
            hPort = PACNET.UART.Open("");

            //Get slot data
            SlotNumber = Convert.ToInt16(cmbSlot.Text);

            //Get Channel data
            int intChannel = Convert.ToInt16(txtChannel.Text);

            //Write data
            bool iRet = PACNET.PAC_IO.WriteDO_MF(hPort, SlotNumber, intChannel, Convert.ToUInt32(txtHexValue.Text, 16));

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
        }

        private void btnClear_MF_Click(object sender, EventArgs e)
        {
            IntPtr hPort;

            //Open default com port , default com port is com 1
            hPort = PACNET.UART.Open("");

            //Set do data be '0' to clear
            bool iRet = PACNET.PAC_IO.WriteDO_MF(hPort, SlotNumber, Convert.ToInt16(txtChannel.Text), 0);

            if (!iRet)
            {
                uint ec = PACNET.ErrHandling.GetLastError();
                MessageBox.Show(((PACNET.ErrCode)ec).ToString() + "\nError Code: 0x" + ec.ToString("X"));
            }

            PACNET.UART.Close(hPort);
            txtHexValue.Text = "0";
        }
    }
}