using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using pac8024WNet;

namespace pac_i8024W_Dotnet
{
    public partial class Form1 : Form
    {
        private string[] typeStr = new string[5];
        private string[] slotStr = new string[8];
        private string[] chStr = new string[4];

       

        
        public Form1()
        {
            typeStr[0] = "Voltage(+/- 10.0)(unit: V)";
            typeStr[1] = "Current(0.0 ~ 20.0)(unit: mA)";
            typeStr[2] = "Voltage(-32768~32767)(unit: none)";
            typeStr[3] = "Current(0~32768)(unit: none)";

            slotStr[0] = "Slot 0";
            slotStr[1] = "Slot 1";
            slotStr[2] = "Slot 2";
            slotStr[3] = "Slot 3";
            slotStr[4] = "Slot 4";
            slotStr[5] = "Slot 5";
            slotStr[6] = "Slot 6";
            slotStr[7] = "Slot 7";

            chStr[0] = "Channel 0";
            chStr[1] = "Channel 1";
            chStr[2] = "Channel 2";
            chStr[3] = "Channel 3";
            

            InitializeComponent();
        }




        private void Form1_Load(object sender, EventArgs e)
        {
            
            for (int i = 0; i < 4; i++)
            {
                cboRange.Items.Add(typeStr[i]);
            }
            for (int i = 0; i < 8; i++)
            {
                cboSlotIndex.Items.Add(slotStr[i]);
            }
            for (int i = 0; i < 4; i++)
            {
                cboChIndex.Items.Add(chStr[i]);
            }
            txtLibVer.Text = String.Format("{0:X4}", pac8024W.LibVersion()); 
            txtLibDate.Text = pac8024W.LibDate();
            
        }



 
        private void btnExit_Click(object sender, EventArgs e)
        {

            
            
            Application.Exit();
        }

        private void btnAO_Click(object sender, EventArgs e)
        {
            Int16 slotIndex,chIndex;
           
            slotIndex = (Int16)cboSlotIndex.SelectedIndex;
            chIndex = (Int16)cboChIndex.SelectedIndex;

            switch (cboRange.SelectedIndex)
            {
                case 0:
                    if (Convert.ToSingle(txtAO.Text) > 10.0 || Convert.ToSingle(txtAO.Text) < -10.0)
                    {
                        sBar.Text = "Output Data out of range";
                    }
                    else
                    {
                        pac8024W.VoltageOut(slotIndex, chIndex, Convert.ToSingle(txtAO.Text));
                        sBar.Text = "";
                    }
                    break;
                case 1:
                    if (Convert.ToSingle(txtAO.Text) > 20.0 || Convert.ToSingle(txtAO.Text) < 0.0)
                    {
                        sBar.Text = "Output Data out of range";

                    }
                    else
                    {
                        pac8024W.CurrentOut(slotIndex, chIndex, Convert.ToSingle(txtAO.Text));
                        sBar.Text = "";
                    }
                    break;
                case 2:
                    if (Convert.ToInt16(txtAO.Text) > 32767 || Convert.ToInt16(txtAO.Text) < -32768)
                    {
                        sBar.Text = "Output Data out of range";

                    }
                    else
                    {
                        pac8024W.VoltageOut_Hex(slotIndex, chIndex, Convert.ToInt16(txtAO.Text));
                        sBar.Text = "";
                    }
                    break;
                case 3:
                    if (Convert.ToInt16(txtAO.Text) > 32767 || Convert.ToInt16(txtAO.Text) < 0)
                    {
                        sBar.Text = "Output Data out of range";

                    }
                    else
                    {
                        pac8024W.CurrentOut_Hex(slotIndex, chIndex, Convert.ToInt16(txtAO.Text));
                        sBar.Text = "";
                    }
                    break;
            }
        }

        private void cboSlotIndex_SelectedIndexChanged(object sender, EventArgs e)
        {
            Int16 slotIndex =(Int16) cboSlotIndex.SelectedIndex;
            Int16 ret = pac8024W.Init(slotIndex);
            if (ret == 0)
                lbID.Text = "Find a 8024W at slot " + slotIndex.ToString();
            else
                lbID.Text = "No 8024W at slot " + slotIndex.ToString();
        }

       
    }
}