Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cmbDOSlot.SelectedIndex = 3
    End Sub
    Private iSlot As Integer
    Private iCurrentCh As Integer
    Private iTotalCh As Integer
    Private fValue As Single

    Private Sub GetTxtValue()
        iSlot = Convert.ToInt32(cmbDOSlot.Text)
        iCurrentCh = Convert.ToInt32(txtCurrentCH.Text)
        iTotalCh = Convert.ToInt32(txtTotalCH.Text)
        fValue = Convert.ToSingle(txtValue.Text)
    End Sub
    Private Sub btnReadPower_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadPower.Click
        GetTxtValue()
        Dim data As Single = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ReadModulePowerOnValueAO(hPort, iSlot, iCurrentCh, iTotalCh, data)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtRead.Text = "Read PowerOn ValueAO: " + data.ToString()
    End Sub

    Private Sub btnWritePower_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWritePower.Click
        GetTxtValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteModulePowerOnValueAO(hPort, iSlot, iCurrentCh, iTotalCh, fValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnReadSafe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadSafe.Click
        GetTxtValue()
        Dim data As Single = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ReadModuleSafeValueAO(hPort, iSlot, iCurrentCh, iTotalCh, data)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtRead.Text = "Read Safe ValueAO: " + data.ToString()
    End Sub

    Private Sub btnWriteSafe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteSafe.Click
        GetTxtValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteModuleSafeValueAO(hPort, iSlot, iCurrentCh, iTotalCh, fValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        Dim hPort As IntPtr = PACNET.UART.Open("")
        'Write AO value
        Dim iRet As Boolean = PACNET.PAC_IO.WriteAO(hPort, iSlot, iCurrentCh, iTotalCh, fValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        GetTxtValue()

        Dim data As Single = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ReadAO(hPort, iSlot, iCurrentCh, iTotalCh, data)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtRead.Text = "Read AO: " + data.ToString()
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        GetTxtValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteAO(hPort, iSlot, iCurrentCh, iTotalCh, 0.0F)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtValue.Text = "0"
    End Sub

    Private Sub btnCfgWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCfgWDT.Click
        GetTxtValue()

        Dim WTDTimeout As Integer = 0

        WTDTimeout = Convert.ToInt32(txtbWTDTimeout.Text)

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.SetModuleWDTConfig(hPort, iSlot, 1, WTDTimeout, 0)
        '87k module without WTDOverwrite
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnGetWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetWDT.Click
        GetTxtValue()

        'pac_GetModuleWDTConfig
        Dim WTDOverwrite As Integer = 0
        Dim WTDTimeout As Integer = 0
        Dim ebStatus As Short = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.GetModuleWDTConfig(hPort, iSlot, ebStatus, WTDTimeout, WTDOverwrite)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtbWTDTimeout.Text = WTDTimeout.ToString()
    End Sub

    Private Sub btnRestWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRestWDT.Click
        GetTxtValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ResetModuleWDT(hPort, iSlot)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnRefreshWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRefreshWDT.Click
        GetTxtValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.RefreshModuleWDT(hPort, iSlot)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub
End Class
