Public Class Form1
    Private Const DI_MAX_TOTAL_CH As Integer = 8
    Private Const DO_MAX_TOTAL_CH As Integer = 8

    Private Const DIAMETER As Integer = 60
    Private Const GAP_CIRCLE_HL As Integer = 5
    Private Const LENGTH_CUBE_HL_DIVIDED_3 As Integer = 9
    Private Const GAP_H_L As Integer = DIAMETER - LENGTH_CUBE_HL_DIVIDED_3 * 3 * 2
    Private Const GAP_HL_LABEL As Integer = 5
    Private Const LABEL_WIDTH As Integer = DIAMETER
    Private Const LABEL_HEIGHT As Integer = 20
    Private Const GAP_DI_DO As Integer = 10
    Private Const CHECKBOX_WIDTH As Integer = DIAMETER
    Private Const CHECKBOX_HEIGHT As Integer = 20
    Private Const GAP_CHECKBOX_HL As Integer = 5
    Private Const GAP_HORIZONTAL As Integer = 10

    Private diValue As UInteger
    Private doValue As UInteger
    Private DILowLatchValue As UInteger = 0
    Private DIHighLatchValue As UInteger = 0
    Private DOLowLatchValue As UInteger = 0
    Private DOHighLatchValue As UInteger = 0

    Private Hshape() As Boolean = {True, False, True, True, True, True, True, False, True}
    'H shape:
    '  T F T
    '  T T T
    '  T F T
    Private Lshape() As Boolean = {True, False, False, True, False, False, True, True, True}
    'L shape:
    '  T F F
    '  T F F
    '  T T T

    Private cbArr(DO_MAX_TOTAL_CH - 1) As CheckBox
    Private lbArr(DI_MAX_TOTAL_CH - 1) As Label
    Public Sub New()
        InitializeComponent()

        For i As Integer = 0 To DO_MAX_TOTAL_CH - 1
            cbArr(i) = New CheckBox()
            AddHandler cbArr(i).CheckStateChanged, AddressOf checkBox_CheckStateChanged
            Me.panel1.Controls.Add(cbArr(i))
        Next i

        For i As Integer = 0 To DI_MAX_TOTAL_CH - 1
            lbArr(i) = New Label()
            Me.panel1.Controls.Add(lbArr(i))
        Next i
    End Sub
    Private Sub button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button1.Click
        Dim slot As Integer = cbbSlot.SelectedIndex + 1
        Dim total_DI_ch As Integer = Integer.Parse(cbbDICh.Items(cbbDICh.SelectedIndex).ToString())
        Dim total_DO_ch As Integer = Integer.Parse(cbbDOCh.Items(cbbDOCh.SelectedIndex).ToString())
        Dim h As IntPtr = PACNET.UART.Open("")

        'Read DIO
        diValue = 0
        doValue = 0
        PACNET.PAC_IO.ReadDIO(h, slot, total_DI_ch, total_DO_ch, diValue, doValue)
        textBox1.Text = diValue.ToString()
        textBox2.Text = doValue.ToString()

        'Read DIO Low Latch
        DILowLatchValue = 0
        DOLowLatchValue = 0
        PACNET.PAC_IO.ReadDIOLatch(h, slot, total_DI_ch, total_DO_ch, 0, DILowLatchValue, DOLowLatchValue)
        textBox7.Text = DILowLatchValue.ToString()
        textBox6.Text = DOLowLatchValue.ToString()

        'Read DIO High Latch
        DOHighLatchValue = 0
        DIHighLatchValue = 0
        PACNET.PAC_IO.ReadDIOLatch(h, slot, total_DI_ch, total_DO_ch, 1, DIHighLatchValue, DOHighLatchValue)
        textBox5.Text = DIHighLatchValue.ToString()
        textBox4.Text = DOHighLatchValue.ToString()

        PACNET.UART.Close(h)

        panel1.Refresh()
    End Sub

    Private Sub button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button3.Click
        Dim slot As Integer = cbbSlot.SelectedIndex + 1

        Dim h As IntPtr = PACNET.UART.Open("")

        PACNET.PAC_IO.ClearDIOLatch(h, slot)

        PACNET.UART.Close(h)
    End Sub

    Private Sub button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles button2.Click
        Dim slot As Integer = cbbSlot.SelectedIndex + 1
        Dim total_DO_ch As Integer = Integer.Parse(cbbDOCh.Items(cbbDOCh.SelectedIndex).ToString())
        Dim DO_Value As UInteger = UInteger.Parse(textBox3.Text)

        Dim h As IntPtr = PACNET.UART.Open("")

        PACNET.PAC_IO.WriteDO(h, slot, total_DO_ch, DO_Value)

        PACNET.UART.Close(h)
    End Sub

    Private Sub cbbDOCh_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbbDOCh.SelectedIndexChanged
        Dim total_DO_ch As Integer = Integer.Parse(cbbDOCh.Items(cbbDOCh.SelectedIndex).ToString())
        printCheckBoxs(total_DO_ch)
        panel1.Refresh()
    End Sub

    Private Sub cbbDICh_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbbDICh.SelectedIndexChanged
        Dim total_DI_ch As Integer = Integer.Parse(cbbDICh.Items(cbbDICh.SelectedIndex).ToString())

        panel1.Refresh()
        printLabels(total_DI_ch)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        cbbSlot.SelectedIndex = 0
        cbbDICh.SelectedIndex = 0
        cbbDOCh.SelectedIndex = 0
        Dim total_DI_ch As Integer = Integer.Parse(cbbDICh.Items(cbbDICh.SelectedIndex).ToString())
        Dim total_DO_ch As Integer = Integer.Parse(cbbDOCh.Items(cbbDOCh.SelectedIndex).ToString())

        printCheckBoxs(total_DO_ch)
        printLabels(total_DI_ch)
    End Sub
    Private Sub printCheckBoxs(ByVal channel As Integer)
        Dim x As Integer = 10
        Dim y As Integer = 10 + DIAMETER + GAP_CIRCLE_HL + LENGTH_CUBE_HL_DIVIDED_3 * 3 + GAP_HL_LABEL + LABEL_HEIGHT + GAP_DI_DO

        Dim vertical_shift As Integer = DIAMETER + GAP_CIRCLE_HL + LENGTH_CUBE_HL_DIVIDED_3 * 3 + GAP_HL_LABEL + LABEL_HEIGHT + GAP_DI_DO + CHECKBOX_HEIGHT + GAP_CHECKBOX_HL
        Dim horizontal_shift As Integer = DIAMETER + GAP_HORIZONTAL

        For i As Integer = 0 To channel - 1
            cbArr(i).Location = New Point(x + horizontal_shift * (i Mod 8), y + vertical_shift * (i \ 8))
            cbArr(i).Size = New Size(CHECKBOX_WIDTH, CHECKBOX_HEIGHT)
            cbArr(i).Text = "DO_" & i.ToString("00")
            cbArr(i).Visible = True
        Next i

        For j As Integer = channel To DO_MAX_TOTAL_CH - 1
            cbArr(j).Visible = False
        Next j
    End Sub
    Private Sub checkBox_CheckStateChanged(ByVal sender As Object, ByVal e As EventArgs)
        Dim DO_value As UInteger = 0
        Dim one As UInteger = 1

        For i As Integer = 0 To DO_MAX_TOTAL_CH - 1
            If (cbArr(i).Visible = True) AndAlso (cbArr(i).Checked = True) Then
                DO_value += one << (Integer.Parse(i.ToString()))
            End If
        Next i
        textBox3.Text = DO_value.ToString()
    End Sub
    Private Sub printLabels(ByVal channel As Integer)
        Dim x As Integer = 10
        Dim y As Integer = 10 + DIAMETER + GAP_CIRCLE_HL + LENGTH_CUBE_HL_DIVIDED_3 * 3 + GAP_HL_LABEL

        Dim vertical_shift As Integer = DIAMETER + GAP_CIRCLE_HL + LENGTH_CUBE_HL_DIVIDED_3 * 3 + GAP_HL_LABEL + LABEL_HEIGHT + GAP_DI_DO + CHECKBOX_HEIGHT + GAP_CHECKBOX_HL
        Dim horizontal_shift As Integer = DIAMETER + GAP_HORIZONTAL

        For i As Integer = 0 To channel - 1
            lbArr(i).Location = New Point(x + horizontal_shift * (i Mod 8), y + vertical_shift * (i \ 8))
            lbArr(i).Size = New Size(LABEL_WIDTH, LABEL_HEIGHT)
            lbArr(i).Text = "DI_" & i.ToString("00")
            lbArr(i).Visible = True
        Next i

        For j As Integer = channel To DO_MAX_TOTAL_CH - 1
            lbArr(j).Visible = False
        Next j
    End Sub
    Private Sub panel1_Paint(ByVal sender As Object, ByVal e As PaintEventArgs) Handles panel1.Paint
        Dim x As Integer = 10
        Dim y As Integer = 10
        Dim vertical_shift As Integer = DIAMETER + GAP_CIRCLE_HL + LENGTH_CUBE_HL_DIVIDED_3 * 3 + GAP_HL_LABEL + LABEL_HEIGHT + GAP_DI_DO + CHECKBOX_HEIGHT + GAP_CHECKBOX_HL
        Dim horizontal_shift As Integer = DIAMETER + GAP_HORIZONTAL

        Dim DI_vertical_shift_HL As Integer = DIAMETER + GAP_CIRCLE_HL
        Dim DI_horizontal_shift_L As Integer = LENGTH_CUBE_HL_DIVIDED_3 * 3 + GAP_H_L
        Dim DO_vertical_shift_HL As Integer = DIAMETER + GAP_CIRCLE_HL + LENGTH_CUBE_HL_DIVIDED_3 * 3 + GAP_HL_LABEL + LABEL_HEIGHT + GAP_DI_DO + CHECKBOX_HEIGHT + GAP_CHECKBOX_HL
        Dim DO_horizontal_shift_L As Integer = LENGTH_CUBE_HL_DIVIDED_3 * 3 + GAP_H_L

        Dim total_DI_ch As Integer = Integer.Parse(cbbDICh.Items(cbbDICh.SelectedIndex).ToString())
        Dim total_DO_ch As Integer = Integer.Parse(cbbDOCh.Items(cbbDOCh.SelectedIndex).ToString())

        Dim bs As Brush

        Dim p As New Pen(Color.Black)
        Dim black As Brush = New SolidBrush(Color.Black)
        Dim blue As Brush = New SolidBrush(Color.Blue)
        Dim green As Brush = New SolidBrush(Color.Green)
        Dim red As Brush = New SolidBrush(Color.Red)
        bs = black

        For i As Integer = 0 To total_DI_ch - 1
            'print DI value:
            If PACNET.PAC_IO.GetBit(Integer.Parse(diValue.ToString()), i) Then
                bs = red
            Else
                bs = black
            End If
            e.Graphics.FillEllipse(bs, x + horizontal_shift * (i Mod 8), y + vertical_shift * (i \ 8), DIAMETER, DIAMETER)

            'print DI Low latch status:
            If PACNET.PAC_IO.GetBit(Integer.Parse(DILowLatchValue.ToString()), i) Then
                bs = green
            Else
                bs = black
            End If
            printShape(e, bs, x + DI_horizontal_shift_L + horizontal_shift * (i Mod 8), y + DI_vertical_shift_HL + vertical_shift * (i \ 8), LENGTH_CUBE_HL_DIVIDED_3, Lshape)

            'print DI High latch status:
            If PACNET.PAC_IO.GetBit(Integer.Parse(DIHighLatchValue.ToString()), i) Then
                bs = blue
            Else
                bs = black
            End If
            printShape(e, bs, x + horizontal_shift * (i Mod 8), y + DI_vertical_shift_HL + vertical_shift * (i \ 8), LENGTH_CUBE_HL_DIVIDED_3, Hshape)

        Next i

        For i As Integer = 0 To total_DO_ch - 1
            'print DO Low latch status:
            If PACNET.PAC_IO.GetBit(Integer.Parse(DOLowLatchValue.ToString()), i) Then
                bs = green
            Else
                bs = black
            End If
            printShape(e, bs, x + DO_horizontal_shift_L + horizontal_shift * (i Mod 8), y + DO_vertical_shift_HL + vertical_shift * (i \ 8), LENGTH_CUBE_HL_DIVIDED_3, Lshape)

            'print DO High latch status:
            If PACNET.PAC_IO.GetBit(Integer.Parse(DOHighLatchValue.ToString()), i) Then
                bs = blue
            Else
                bs = black
            End If
            printShape(e, bs, x + horizontal_shift * (i Mod 8), y + DO_vertical_shift_HL + vertical_shift * (i \ 8), LENGTH_CUBE_HL_DIVIDED_3, Hshape)
        Next i

    End Sub
    'print shape of characters. (H or L)
    Private Sub printShape(ByVal e As PaintEventArgs, ByVal b As Brush, ByVal x As Integer, ByVal y As Integer, ByVal length As Integer, ByVal shape() As Boolean)
        For i As Integer = 0 To 2
            For j As Integer = 0 To 2
                If shape(j + 3 * i) Then
                    e.Graphics.FillRectangle(b, x + length * j, y + length * i, length, length)
                End If
            Next j
        Next i
    End Sub

    Private Sub textBox3_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles textBox3.KeyDown
        If e.KeyData = Keys.Enter Then
            Dim DO_value As UInteger = UInteger.Parse(textBox3.Text)

            For i As Integer = 0 To DO_MAX_TOTAL_CH - 1
                If 1 = (1 And (DO_value >> i)) Then
                    cbArr(i).Checked = True
                Else
                    cbArr(i).Checked = False
                End If
            Next i
        End If
    End Sub
End Class
