Public Class Form1
    Private iSlot As Integer
    Private iTotalCh As Integer
    Private lDO_Value As UInteger

    Private Sub GetTextValue()
        iSlot = Convert.ToInt32(cmbSlot.Text)
        'Get slot
        lDO_Value = Convert.ToUInt32(txtValue.Text, 16)
        'Get DO Value
        iTotalCh = Convert.ToInt32(txtChannels.Text)
        'Get Total Channels
    End Sub
    Private Sub btnWrite_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite.Click
        GetTextValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteDO(hPort, iSlot, iTotalCh, lDO_Value)
        'Write DO value
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        GetTextValue()

        Dim data As UInteger = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ReadDO(hPort, iSlot, iTotalCh, data)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtRead.Text = "ReadDO(HEX): " + data.ToString("x")
    End Sub

    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        GetTextValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteDO(hPort, iSlot, iTotalCh, 0)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtValue.Text = "0"
    End Sub

    Private Sub btnReadPower_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadPower.Click
        GetTextValue()

        Dim lValue As Long = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ReadModulePowerOnValueDO(hPort, iSlot, iTotalCh, lValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtRead.Text = "Read PowerOn ValueDO(HEX): " + lValue.ToString("x")
    End Sub

    Private Sub btnWritePower_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWritePower.Click
        GetTextValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteModulePowerOnValueDO(hPort, iSlot, iTotalCh, lDO_Value)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnReadSafe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadSafe.Click
        GetTextValue()

        Dim lValue As Long = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ReadModuleSafeValueDO(hPort, iSlot, iTotalCh, lValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtRead.Text = "Read Safe ValueDO(HEX): " + lValue.ToString("x")
    End Sub

    Private Sub btnWriteSafe_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteSafe.Click
        GetTextValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteModuleSafeValueDO(hPort, iSlot, iTotalCh, lDO_Value)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnCfgWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCfgWDT.Click
        GetTextValue()

        Dim WTDTimeout As Integer = 0

        WTDTimeout = Convert.ToInt32(txtbWTDTimeout.Text)

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.SetModuleWDTConfig(hPort, iSlot, 1, WTDTimeout, 0)
        '87k module without WTDOverwrite
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnGetWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetWDT.Click
        GetTextValue()

        Dim WTDOverwrite As Integer = 0
        Dim WTDTimeout As Integer = 0
        Dim ebStatus As Short = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.GetModuleWDTConfig(hPort, iSlot, ebStatus, WTDTimeout, WTDOverwrite)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtbWTDTimeout.Text = WTDTimeout.ToString()
    End Sub

    Private Sub btnRestWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRestWDT.Click
        GetTextValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ResetModuleWDT(hPort, iSlot)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnRefreshWDT_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRefreshWDT.Click
        GetTextValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.RefreshModuleWDT(hPort, iSlot)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnRead_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead_MF.Click
        GetTextValue()

        Dim data As UInteger = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ReadDO_MF(hPort, iSlot, iTotalCh, data)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtRead.Text = "ReadDO(HEX): " + data.ToString("x")
    End Sub

    Private Sub btnWrite_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWrite_MF.Click
        GetTextValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteDO_MF(hPort, iSlot, iTotalCh, lDO_Value)
        'Write DO value
        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnClear_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear_MF.Click
        GetTextValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteDO_MF(hPort, iSlot, iTotalCh, 0)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtValue.Text = "0"
    End Sub

    Private Sub btnReadPower_Mf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadPower_Mf.Click
        GetTextValue()

        Dim lValue As Long = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ReadModulePowerOnValueDO_MF(hPort, iSlot, iTotalCh, lValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtRead.Text = "Read PowerOn ValueDO(HEX): " + lValue.ToString("x")
    End Sub

    Private Sub btnWritePower_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWritePower_MF.Click
        GetTextValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteModulePowerOnValueDO_MF(hPort, iSlot, iTotalCh, lDO_Value)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub

    Private Sub btnReadSafe_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnReadSafe_MF.Click
        GetTextValue()

        Dim lValue As Long = 0

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.ReadModuleSafeValueDO_MF(hPort, iSlot, iTotalCh, lValue)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
        txtRead.Text = "Read Safe ValueDO(HEX): " + lValue.ToString("x")
    End Sub

    Private Sub btnWriteSafe_MF_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnWriteSafe_MF.Click
        GetTextValue()

        Dim hPort As IntPtr = PACNET.UART.Open("")
        Dim iRet As Boolean = PACNET.PAC_IO.WriteModuleSafeValueDO_MF(hPort, iSlot, iTotalCh, lDO_Value)

        If Not iRet Then
            Dim ec As UInteger = PACNET.ErrHandling.GetLastError()
            MessageBox.Show(CType(ec, PACNET.ErrCode).ToString() + vbLf & "Error Code: 0x" + ec.ToString("X"))
        End If

        PACNET.UART.Close(hPort)
    End Sub
End Class
