﻿
Imports pac8017HWNet
Public Class Form1


    Inherits Form
    Private typeStr As String() = New String(5) {}
    Private slotStr As String() = New String(8) {}
    Private jumperStr As String() = New String(2) {}
    Private slotIndex As Integer
    Private gain As Integer
    Private ifSingleEnded As Int16 = 0
    Private firmware As Int16 = 0
    Private totalCh As Integer




    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        typeStr(0) = "Voltage +/- 10.0 V "
        typeStr(1) = "Voltage +/-  5.0 V "
        typeStr(2) = "Voltage +/-  2.5 V "
        typeStr(3) = "Voltage +/-  1.25 V "
        typeStr(4) = "Voltage +/- 20.0 mA "

        slotStr(0) = "Slot 0"
        slotStr(1) = "Slot 1"
        slotStr(2) = "Slot 2"
        slotStr(3) = "Slot 3"
        slotStr(4) = "Slot 4"
        slotStr(5) = "Slot 5"
        slotStr(6) = "Slot 6"
        slotStr(7) = "Slot 7"

        jumperStr(0) = "Differential"
        jumperStr(1) = "Single Ended"


        Dim i As Integer = 0
        For i = 0 To 4
            cboRange.Items.Add(typeStr(i))
        Next i

        For i = 0 To 7
            cboSlotIndex.Items.Add(slotStr(i))
        Next i

    End Sub

    
    Private Sub btnAI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAI.Click

        Dim aiText As TextBox() = New TextBox() {txtAI00, txtAI01, txtAI02, txtAI03, txtAI04, txtAI05, _
         txtAI06, txtAI07, txtAI08, txtAI09, txtAI10, txtAI11, _
         txtAI12, txtAI13, txtAI14, txtAI15}
        Dim fValue As Single = 0
        Dim iValue As Int16 = 0
        Dim valStr As String

       

        gain = cboRange.SelectedIndex

        Dim ch As Integer
        ch = 0
        For ch = 0 To totalCh - 1
            If frdo.Checked = True Then
                pac8017HW.ReadAI(slotIndex, ch, gain, fValue)
                valStr = [String].Format("{0:00.000}", fValue)
                aiText(ch).Text = valStr
            Else
                pac8017HW.ReadAIHex(slotIndex, ch, gain, iValue)
                valStr = [String].Format("{0:X4}", iValue)
                aiText(ch).Text = valStr
            End If

        Next ch
    End Sub

    Private Sub cboSlotIndex_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlotIndex.SelectedIndexChanged
        Dim ret As Int16
        slotIndex = cboSlotIndex.SelectedIndex

        ret = pac8017HW.Init(slotIndex)
        If ret <> 0 Then
            MessageBox.Show("Can not find I-8017HW at " + slotIndex.ToString() + "ret=" + ret.ToString())
            btnAI.Enabled = False
        Else
            txtLibVer.Text = [String].Format("{0:X4}", pac8017HW.LibVersion())

            txtLibDate.Text = pac8017HW.LibDate()
            pac8017HW.FirmwareVersion(slotIndex, firmware)
            txtFirmware.Text = [String].Format("{0:X4}", firmware)


            pac8017HW.SingleEndJumper(slotIndex, ifSingleEnded)
            txtJumper.Text = jumperStr(ifSingleEnded)
            If ifSingleEnded = 1 Then
                totalCh = 16
            Else
                totalCh = 8
            End If
            btnAI.Enabled = True
        End If

    End Sub

    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub
End Class
