﻿Imports pac8084WNet
Public Class Form1

    Private typeStr As String() = New String(4) {}
    Private slotStr As String() = New String(7) {}
    Private slotIndex As Integer = -1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer
        typeStr(0) = "Pulse / Dir"
        typeStr(1) = "Up / Down"
        typeStr(2) = "Frequency"
        typeStr(3) = "Up Counter"
        typeStr(4) = "A/B Phase"

        slotStr(0) = "Slot 0"
        slotStr(1) = "Slot 1"
        slotStr(2) = "Slot 2"
        slotStr(3) = "Slot 3"
        slotStr(4) = "Slot 4"
        slotStr(5) = "Slot 5"
        slotStr(6) = "Slot 6"
        slotStr(7) = "Slot 7"

        For i = 0 To 4
            cboRange.Items.Add(typeStr(i))
        Next i

        For i = 0 To 7
            cboSlotIndex.Items.Add(slotStr(i))
        Next i
    End Sub

    Private Sub btnRead_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRead.Click
        Timer1.Enabled = True
        Timer1.Interval = 100
    End Sub

  


    Private Sub btnClr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClr.Click
        Dim ch As Integer = 0
        For ch = 0 To 7
            pac8084W.ClrCnt(slotIndex, ch)
        Next ch

    End Sub

  

    
    
    Private Sub cboSlotIndex_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlotIndex.SelectedIndexChanged
        Dim ret As Integer
        slotIndex = cboSlotIndex.SelectedIndex
        ret = pac8084W.Init(slotIndex)

        If ret = 0 Then
            txtLibVer.Text = [String].Format("{0:X4}", pac8084W.LibVersion())

            txtLibDate.Text = pac8084W.LibDate()


        Else
            MessageBox.Show("Can not find I-8084 at Slot " + cboSlotIndex.SelectedIndex.ToString())
            txtLibVer.Text = "-1"
            txtLibDate.Text = "none"
        End If
    End Sub

   
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()
    End Sub

    Private Sub cboRange_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboRange.SelectedIndexChanged
        Dim mode As Integer
        Dim ch As Integer = 0

        If slotIndex <> -1 Then
            mode = cboRange.SelectedIndex

            For ch = 0 To 7
                pac8084W.SetChannelMode(slotIndex, ch, mode) ' for Demo to set all channels as same channel mode

                pac8084W.ClrCnt(slotIndex, ch)
            Next ch
        End If
    End Sub

    
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Dim ret As Int16, mode As Int16
        Dim valText As TextBox() = New TextBox() {txtCH00, txtCH01, txtCH02, txtCH03, txtCH04, txtCH05, _
         txtCH06, txtCH07}
        Dim ovText As TextBox() = New TextBox() {txtOv0, txtOv1, txtOv2, txtOv3, txtOv4, txtOv5, _
         txtOv6, txtOv7}
        Dim ulVal As UInt32 = 0
        Dim uVal As UInt16 = 0
        Dim lVal As Int32 = 0
        Dim iVal As Int16 = 0
        Dim ch As Integer


        If slotIndex <> -1 Then
            mode = cboRange.SelectedIndex


            ch = 0
            For ch = 0 To 7

                Select Case mode
                    Case 0
                        pac8084W.ReadPulseDir(slotIndex, ch, lVal, iVal)
                        valText(ch).Text = lVal.ToString()
                        ovText(ch).Text = iVal.ToString()
                        Exit Select
                    Case 1
                        pac8084W.ReadUpDown(slotIndex, ch, lVal, iVal)
                        valText(ch).Text = lVal.ToString()
                        ovText(ch).Text = iVal.ToString()
                        Exit Select
                    Case 2
                        pac8084W.ReadFreq(slotIndex, ch, ulVal)
                        valText(ch).Text = ulVal.ToString()
                        ovText(ch).Text = "-none-"
                        Exit Select
                    Case 3
                        pac8084W.ReadUpCnt(slotIndex, ch, ulVal, uVal)
                        valText(ch).Text = ulVal.ToString()
                        ovText(ch).Text = uVal.ToString()
                        Exit Select
                    Case 4
                        pac8084W.ReadABPhase(slotIndex, ch, lVal, iVal)
                        valText(ch).Text = lVal.ToString()
                        ovText(ch).Text = iVal.ToString()
                        Exit Select

                End Select
            Next ch
        End If
    End Sub

    Private Sub Form1_Closing(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        Timer1.Enabled = False
    End Sub
End Class
