﻿Imports pac8172WNet
Public Class Form1
    Private Shared slotIndex As Integer = 0, port As Integer = 0, group As Integer = 8
    Private Shared bitMode As Int16 = 12, jumper As Int16 = 0

    'Step 1 call pac8172W.Init and check the return code
    Private Sub cboSlot_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboSlot.SelectedIndexChanged
        Dim ret As Integer = -1

        ret = pac8172W.Init(cboSlot.SelectedIndex)
        If ret = 0 Then
            slotIndex = cboSlot.SelectedIndex
        Else
            MessageBox.Show("I-8172W is not at slot " + cboSlot.SelectedIndex.ToString())
        End If
    End Sub
    Private Sub cboPort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboPort.SelectedIndexChanged
        port = cboPort.SelectedIndex
    End Sub

    ' for input FRnet I/O , the group index start from 8~15
    ' for output FRnet I/O the group index start from 0~7
    Private Sub cboGroup_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboGroup.SelectedIndexChanged
        group = cboGroup.SelectedIndex + 8
    End Sub

    ' if FR-2017 jumper =1 
    Private Sub cboJumper_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboJumper.SelectedIndexChanged
        jumper = cboJumper.SelectedIndex
    End Sub
    Private Sub cboBit_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboBit.SelectedIndexChanged
        If (cboBit.SelectedIndex = 0) Then
            bitMode = 12
        Else
            bitMode = 16
        End If

    End Sub
    Private Sub btnAI_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAI.Click
        Dim ret As Int16, ch As Int16 = 0, flag As Int16 = -1, i As Int16
        Dim checkArr As Int16(), iArr As Int16()
        Dim iVal As Int16 = 0
        Dim typeCode As Integer()
        'float[] aiFloat= new float[16];
        Dim fVal As Single = 0
        Dim maxCh As Integer = 8

        Dim txtAI As TextBox() = {txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5, _
         txtAI6, txtAI7, txtAI8, txtAI9, txtAI10, txtAI11, _
         txtAI12, txtAI13, txtAI14, txtAI15}
        Dim cbo As ComboBox() = {cboType0, cboType1, cboType2, cboType3, cboType4, cboType5, _
         cboType6, cboType7, cboType8, cboType9, cboType10, cboType11, _
         cboType12, cboType13, cboType14, cboType15}

        checkArr = New Int16(15) {}
        typeCode = New Integer(15) {}
        iArr = New Int16(15) {}

        ' check the FR-2017 input module communication status
        Dim groupStatus As Integer = pac8172W.ReadInputGroupStatus(slotIndex, port, group)
        If groupStatus = 1 Then
            lbGroupStatus.Text = "Online"
        Else
            lbGroupStatus.Text = "Offline"
        End If

        ' for FR-2017 if 16-bit mode , the total channel is 1
        If bitMode = 16 Then
            maxCh = 1
        Else ' 12-bit mode
            If jumper = 0 Then
                maxCh = 8   'differential input
            Else
                maxCh = 16  'single ended input
            End If
        End If

        i = 0
        For i = 0 To maxCh - 1
            iArr(i) = 0
            checkArr(i) = 0

            If cbo(i).SelectedIndex = 7 Then
                '0x1a
                typeCode(i) = &H1A
            Else
                typeCode(i) = cbo(i).SelectedIndex + 7
            End If
        Next i

        While True
            ret = pac8172W.ReadAIHex(slotIndex, port, group, bitMode, ch, iVal)

            If ret >= 0 Then
                flag = 1
                iArr(ch) = iVal
                checkArr(ch) = checkArr(ch) + 1
            End If
            i = 0
            For i = 0 To maxCh - 1
                If checkArr(i) = 0 Then
                    flag = -1
                    Exit For
                End If
            Next i
            If flag = 1 Then
                i = 0
                For i = 0 To maxCh - 1
                    pac8172W.AIHexToFloat(iArr(i), typeCode(i), bitMode, fVal)
                    txtAI(i).Text = fVal.ToString()
                Next i
                Return
            End If
        End While  ' while true
    End Sub
    Private Sub btnAICh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAICh.Click
        Dim ret As Short, ch As Short, i As Short
        Dim typeCode As Integer() = New Integer(15) {}
        Dim fVal As Single = 0
        Dim aiFloat As Single() = New Single(15) {}
        Dim maxCh As Integer = 8

        Dim txtAI As TextBox() = {txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5, _
         txtAI6, txtAI7, txtAI8, txtAI9, txtAI10, txtAI11, _
         txtAI12, txtAI13, txtAI14, txtAI15}
        Dim cbo As ComboBox() = {cboType0, cboType1, cboType2, cboType3, cboType4, cboType5, _
         cboType6, cboType7, cboType8, cboType9, cboType10, cboType11, _
         cboType12, cboType13, cboType14, cboType15}



        If bitMode = 16 Then
            maxCh = 1
        Else
            If jumper = 0 Then
                maxCh = 8
            Else
                maxCh = 16
            End If
        End If
        i = 0
        For i = 0 To maxCh - 1
            If cbo(i).SelectedIndex = 7 Then
                '0x1a
                typeCode(i) = &H1A
            Else
                typeCode(i) = cbo(i).SelectedIndex + 7
            End If
        Next i

        ch = 0
        For i = 0 To maxCh - 1
            ret = pac8172W.ReadAI_Ch(slotIndex, port, group, bitMode, typeCode(ch), ch, fVal)
            If ret >= 0 Then

                txtAI(ch).Text = fVal.ToString()
            End If
        Next i

    End Sub
    Private Sub btnAIAll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAIAll.Click
        Dim ret As Short, ch As Short, i As Short
        Dim typeCode As Int16() = New Int16(15) {}
        Dim fVal As Single
        Dim aiFloat As Single() = New Single(15) {}
        Dim maxCh As Int16 = 8
        Dim txtAI As TextBox() = {txtAI0, txtAI1, txtAI2, txtAI3, txtAI4, txtAI5, _
         txtAI6, txtAI7, txtAI8, txtAI9, txtAI10, txtAI11, _
         txtAI12, txtAI13, txtAI14, txtAI15}
        Dim cbo As ComboBox() = {cboType0, cboType1, cboType2, cboType3, cboType4, cboType5, _
         cboType6, cboType7, cboType8, cboType9, cboType10, cboType11, _
         cboType12, cboType13, cboType14, cboType15}



        If bitMode = 16 Then
            maxCh = 1
        Else
            If jumper = 0 Then
                maxCh = 8
            Else
                maxCh = 16
            End If
        End If
        i = 0
        For i = 0 To maxCh - 1
            If cbo(i).SelectedIndex = 7 Then
                '0x1a
                typeCode(i) = &H1A
            Else
                typeCode(i) = cbo(i).SelectedIndex + 7
            End If
        Next i
        ret = pac8172W.ReadAI_All(slotIndex, port, group, bitMode, jumper, typeCode, _
         aiFloat)
        If ret > 0 Then
            ch = 0
            For i = 0 To maxCh - 1
                txtAI(ch).Text = aiFloat(ch).ToString()
            Next i
        End If
    End Sub
    Private Sub btnExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Application.Exit()

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Integer
        Dim cbo As ComboBox() = {cboType0, cboType1, cboType2, cboType3, cboType4, cboType5, _
         cboType6, cboType7, cboType8, cboType9, cboType10, cboType11, _
         cboType12, cboType13, cboType14, cboType15}

        cboPort.SelectedIndex = 0
        cboGroup.SelectedIndex = 0
        cboJumper.SelectedIndex = 0
        cboBit.SelectedIndex = 0
        i = 0
        For i = 0 To 15
            ' type code = 0x8 +-10 V
            cbo(i).SelectedIndex = 1
        Next i
    End Sub

   
End Class
