Imports Microsoft.VisualBasic
Imports System
Imports System.Linq
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms

Namespace Diagnostic
	Partial Public Class Form1
		Inherits Form
		Private Const startX As Integer = 20
		Private Const startY As Integer = 30
		Private Const UNIT_LENGTH As Integer = 55
		Private Const GAP_SLOT As Integer = 5
		Private Const GAP_MODULE_LABEL As Integer = 20
		Private Const LABEL_HEIGHT As Integer = 20

		Private slotCount As Integer = 0
		Private ModuleExist(6) As Boolean
		Private ModuleName(6) As String
		Private lbSlot(6) As Label
		Private lbmoduleName(6) As Label

		Private headImage As Image 'image of CPU-power module
		Private moduleImage As Image 'image of I/O slot module
		Private emptyImage As Image 'image of a slot in empty status
		Private pbHead As New PictureBox()
		Private pbModule(6) As PictureBox

		Public Sub New()
			InitializeComponent()

			headImage = imageList1.Images(1)
			moduleImage = imageList1.Images(2)
			emptyImage = imageList1.Images(0)

			'initialize image of CPU-power module
			pbHead.Image = headImage
			pbHead.SizeMode = PictureBoxSizeMode.StretchImage
			pbHead.Size = New Size(UNIT_LENGTH * 3, UNIT_LENGTH * 3)
			pbHead.Location = New Point(startX, startY)
			Me.Controls.Add(pbHead)



            For i As Integer = 0 To 6
                'initialize Labels of Slot1, Slot2, ...
                lbSlot(i) = New Label()
                lbSlot(i).Text = "Slot " & (i + 1).ToString()
                lbSlot(i).Size = New Size(UNIT_LENGTH, LABEL_HEIGHT)
                Me.Controls.Add(lbSlot(i))

                'initialize PictureBoxs which hold image of I/O module status
                pbModule(i) = New PictureBox()
                pbModule(i).SizeMode = PictureBoxSizeMode.StretchImage
                pbModule(i).Size = New Size(UNIT_LENGTH, UNIT_LENGTH * 3)
                pbModule(i).Location = New Point(startX + UNIT_LENGTH * 3 + GAP_SLOT + (UNIT_LENGTH + GAP_SLOT) * i, startY)
                pbModule(i).Image = emptyImage
                Me.Controls.Add(pbModule(i))

                'initialize Labels to hold module names
                lbmoduleName(i) = New Label()
                lbmoduleName(i).Size = New Size(UNIT_LENGTH, LABEL_HEIGHT)
                Me.Controls.Add(lbmoduleName(i))
            Next i

		End Sub

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			slotCount = PACNET.Sys.GetSlotCount()

			printSlotLabels(startX + UNIT_LENGTH * 3 + GAP_SLOT, startY + UNIT_LENGTH * 3 + GAP_MODULE_LABEL)

			button1_Click(sender, e)
		End Sub

		Private Sub showModuleImages()
			For i As Integer = 1 To 7
				If i <= slotCount Then
					If ModuleExist(i-1) Then
						pbModule(i-1).Image = moduleImage
					Else
						pbModule(i-1).Image = emptyImage
					End If
				Else
					pbModule(i - 1).Visible = False
				End If

			Next i
		End Sub

		Private Sub printSlotLabels(ByVal x As Integer, ByVal y As Integer)
			For i As Integer = 1 To 7
				If i <= slotCount Then
					lbSlot(i - 1).Location = New Point(x + (UNIT_LENGTH + GAP_SLOT) * (i - 1), y)
				Else
					lbSlot(i - 1).Visible = False
				End If

			Next i
		End Sub

		Private Sub printModuleNameLabels(ByVal x As Integer, ByVal y As Integer)
			For i As Integer = 1 To 7
				If i <= slotCount Then
					lbmoduleName(i - 1).Location = New Point(x + (UNIT_LENGTH + GAP_SLOT) * (i - 1), y)
				Else
					lbmoduleName(i - 1).Visible = False
				End If

			Next i
		End Sub

		Private Sub button1_Click(ByVal sender As Object, ByVal e As EventArgs) Handles button1.Click 'Diagnose
			Dim h As IntPtr = PACNET.UART.Open("") 'COM1:,115200,N,8,1
			Dim _for_8K As IntPtr = IntPtr.Zero ' (IntPtr)0; //used for pac_ModuleExists
			Dim moduleType As Integer = 0
			Dim cmd(63) As Byte
			Dim result(63) As Byte

			cmd = PACNET.MISC.AnsiString("$00M")
			For i As Byte = 1 To slotCount
				ModuleExist(i - 1) = PACNET.Sys.ModuleExists(_for_8K, i) 'for 8K IO module only
				If ModuleExist(i - 1) Then
					moduleType = PACNET.Sys.GetModuleName(i, ModuleName(i - 1))
					If 255 = moduleType Then '87K IO modules
						PACNET.Sys.ChangeSlot(i)
						PACNET.UART.SendCmd(h, cmd, result) ' $00M: ask the device name
						Dim strResult As String = PACNET.MISC.WideString(result)
						ModuleName(i - 1) = strResult.Substring(3) 'return format for example: !0087055
					End If
				Else
					ModuleName(i - 1) = ""
				End If
				lbmoduleName(i - 1).Text = ModuleName(i - 1)
			Next i

			PACNET.UART.Close(h)

			printModuleNameLabels(startX + UNIT_LENGTH * 3 + GAP_SLOT, startY - GAP_MODULE_LABEL)

			showModuleImages()
		End Sub

	End Class
End Namespace

